// Generated by Henrik Stuart's .hpp generator: www.unprompted.com/hstuart/
#ifndef array_hpp_a650bf08_e950_4ea1_99bd_a579ae1d2179
#define array_hpp_a650bf08_e950_4ea1_99bd_a579ae1d2179

#include <cstddef>
#include <algorithm>

template<typename T>
class array_traits
{
public:
	typedef T const& reference;
};

template<typename T, std::size_t Size>
class array_scalar_value;

template<typename T, std::size_t Size>
class array_traits<array_scalar_value<T, Size> >
{
public:
	typedef const array_scalar_value<T, Size> reference;
};

template<typename T, std::size_t Size, typename Rep>
class array;

template<typename T, std::size_t Size, typename Arg1, typename Arg2>
class array_addition
{
public:
	explicit array_addition(Arg1 const& a, Arg2 const& b):a_(a), b_(b) {}

	const T operator[](std::size_t i) const { return a_[i] + b_[i]; }

private:
	typename array_traits<Arg1>::reference a_;
	typename array_traits<Arg2>::reference b_;
};

template<typename T, std::size_t Size, typename Arg1, typename Arg2>
class array_multiply
{
public:
	explicit array_multiply(Arg1 const& a, Arg2 const& b):a_(a), b_(b) {}

	const T operator[](std::size_t i) const { return a_[i] * b_[i]; }

private:
	typename array_traits<Arg1>::reference a_;
	typename array_traits<Arg2>::reference b_;
};

template<typename T, std::size_t Size>
class array_scalar_value
{
public:
	explicit array_scalar_value(T const& t):t_(t) {}

	const T operator[](std::size_t i) const { return t_; }

private:
	const T t_;
};

template<typename T, std::size_t Size>
class array_impl
{
public:
	explicit array_impl() { std::fill_n(v_, Size, 0); }

	const std::size_t size() const { return Size; }

	T const& operator[](std::size_t i) const { return v_[i]; }
	T& operator[](std::size_t i) { return v_[i]; }

private:
	T v_[Size];
};

template<typename T, std::size_t Size, typename Rep = array_impl<T, Size> >
class array
{
public:
	explicit array() {}
	array(Rep const& a):rep_(a) {}
	template<typename Array>
	array(Array const& a)
	{
		for (std::size_t i = 0; i < size(); ++i)
			rep_[i] = a[i];
	}

	const std::size_t size() const { return rep_.size(); }

	const T operator[](std::size_t i) const { return rep_[i]; }
	T& operator[](std::size_t i) { return rep_[i]; }

	template<typename Array>
	array& operator=(Array const& a)
	{
		for (std::size_t i = 0; i < size(); ++i)
			rep_[i] = a[i];
		return *this;
	}

private:
	Rep rep_;
};

template<typename T, std::size_t Size, typename Arg1>
inline array<T, Size, array_multiply<T, Size, array<T, Size, Arg1>, array_scalar_value<T, Size> > >
	operator*(array<T, Size, Arg1> const& a, T const& t)
{
	return array<T, Size, array_multiply<T, Size, array<T, Size, Arg1>, 
		array_scalar_value<T, Size> > >(
			array_multiply<T, Size, array<T, Size, Arg1>, array_scalar_value<T, Size> >(a, 
				array_scalar_value<T, Size>(t)));
}

template<typename T, std::size_t Size, typename Arg1>
inline array<T, Size, array_multiply<T, Size, array<T, Size, Arg1>, array_scalar_value<T, Size> > >
	operator*(T const& t, array<T, Size, Arg1> const& a)
{
	return operator*(a, t);
}

template<typename T, std::size_t Size, typename Arg1, typename Arg2>
inline array<T, Size, array_addition<T, Size, array<T, Size, Arg1>, array<T, Size, Arg2> > >
	operator+(array<T, Size, Arg1> const& a, array<T, Size, Arg2> const& b)
{
	return array<T, Size, array_addition<T, Size, array<T, Size, Arg1>, 
		array<T, Size, Arg2> > >(
			array_addition<T, Size, array<T, Size, Arg1>, array<T, Size, Arg2> >(a, b));
}

template<typename T, std::size_t Size, typename Arg1, typename Arg2>
array<T, Size, array_multiply<T, Size, array<T, Size, Arg1>, array<T, Size, Arg2> > >
	operator*(array<T, Size, Arg1> const& a, array<T, Size, Arg2> const& b)
{
	return array<T, Size, array_multiply<T, Size, array<T, Size, Arg1>, 
		array<T, Size, Arg2> > >(
			array_multiply<T, Size, array<T, Size, Arg1>, array<T, Size, Arg2> >(a, b));
}

#endif // array_hpp_a650bf08_e950_4ea1_99bd_a579ae1d2179
