// Generated by Henrik Stuart's .hpp generator: www.unprompted.com/hstuart/
#ifndef array_test_hpp_bf68b031_b047_4d13_92d8_2736b8dded2a
#define array_test_hpp_bf68b031_b047_4d13_92d8_2736b8dded2a

#pragma warning( disable : 4018 4267 )

#include <cppunit/extensions/HelperMacros.h>
#include "array.hpp"

class array_test : public CppUnit::TestFixture 
{
public:
	void test_declaration()
	{
		array<int, 100> a;
		array<double, 5> b;
	}
	void test_size()
	{
		array<int, 100> a;
		CPPUNIT_ASSERT(a.size() == 100);

		array<double, 5> b;
		CPPUNIT_ASSERT(b.size() == 5);
	}
	void test_subscript_read()
	{
		array<int, 100> a;
		for (int i = 0; i < a.size(); ++i)
			CPPUNIT_ASSERT(a[i] == 0);
	}
	void test_subscript_write()
	{
		array<int, 100> a;
		for (int i = 0; i < a.size(); ++i)
			a[i] = 0;

		for (int i = 0; i < a.size(); ++i)
			CPPUNIT_ASSERT(a[i] == 0);

		for (int i = 0; i < a.size(); ++i)
			a[i] = i;

		for (int i = 0; i < a.size(); ++i)
			CPPUNIT_ASSERT(a[i] == i);

		array<int, 100> const& b = a;
		for (int i = 0; i < b.size(); ++i)
			CPPUNIT_ASSERT(b[i] == i);
	}
	void test_scalar_multiplication()
	{
		array<int, 100> a;

		for (int i = 0; i < a.size(); ++i)
			a[i] = i;

		a = a * 5;
		for (int i = 0; i < a.size(); ++i)
			CPPUNIT_ASSERT(a[i] == i * 5);

		for (int i = 0; i < a.size(); ++i)
			a[i] = i;

		a = 8 * a;
		for (int i = 0; i < a.size(); ++i)
			CPPUNIT_ASSERT(a[i] == i * 8);
	}
	void test_array_addition()
	{
		array<int, 100> a;
		array<int, 100> b;

		for (int i = 0; i < a.size(); ++i)
			a[i] = i;
		for (int i = 0; i < b.size(); ++i)
			b[i] = b.size() - i;

		a = a + b;
		for (int i = 0; i < a.size(); ++i)
			CPPUNIT_ASSERT(a[i] == i + (b.size() - i));

		for (int i = 0; i < a.size(); ++i)
			a[i] = i;
		for (int i = 0; i < b.size(); ++i)
			b[i] = b.size() - i;

		a = a + b + a;

		for (int i = 0; i < a.size(); ++i)
			CPPUNIT_ASSERT(a[i] == i + (b.size() - i) + i);
	}

	void test_array_multiplication()
	{
		array<int, 100> a;
		array<int, 100> b;

		for (int i = 0; i < a.size(); ++i)
			a[i] = i + 1;
		for (int i = 0; i < b.size(); ++i)
			b[i] = b.size() - i;

		a = a * b;
		for (int i = 0; i < a.size(); ++i)
			CPPUNIT_ASSERT(a[i] == (i + 1) * (b.size() - i));
	}

	void test_example()
	{
		array<int, 100> a;
		array<int, 100> b;

		for (int i = 0; i < a.size(); ++i)
			a[i] = i + 1;
		for (int i = 0; i < b.size(); ++i)
			b[i] = b.size() - i;

		array<int, 100> x = 5 * a + a * b;
		for (int i = 0; i < a.size(); ++i)
			CPPUNIT_ASSERT(x[i] == 5 * (i + 1) + (i + 1) * (b.size() - i));
	}

private:
	CPPUNIT_TEST_SUITE(array_test);
		CPPUNIT_TEST(test_declaration);
		CPPUNIT_TEST(test_size);
		CPPUNIT_TEST(test_subscript_read);
		CPPUNIT_TEST(test_subscript_write);
		CPPUNIT_TEST(test_scalar_multiplication);
		CPPUNIT_TEST(test_array_addition);
		CPPUNIT_TEST(test_array_multiplication);
		CPPUNIT_TEST(test_example);
	CPPUNIT_TEST_SUITE_END();
};

CPPUNIT_TEST_SUITE_REGISTRATION( array_test );


#endif // array_test_hpp_bf68b031_b047_4d13_92d8_2736b8dded2a
